glibmm: Gio::IOStream Class Reference

glibmm 2.28.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Related Functions
Gio::IOStream Class Reference
Stream Classes

`#include <giomm/iostream.h>`

Inheritance diagram for Gio::IOStream:
[legend]

List of all members.

## Public Member Functions
virtual | ~IOStream ()
GIOStream* | gobj ()
| Provides access to the underlying C GObject.
const GIOStream* | gobj () const
| Provides access to the underlying C GObject.
GIOStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object.
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object.
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Closes a stream.
bool | is_closed () const
| Checks if a stream is closed.
bool | has_pending () const
| Checks if a stream has pending actions.
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Since glibmm 2.22:

## Constructor & Destructor Documentation

virtual Gio::IOStream::~IOStream | ( |  | ) | `[virtual]`

## Member Function Documentation

void Gio::IOStream::clear_pending | ( |  | ) |

Clears the pending flag on stream.

Since glibmm 2.22:

bool Gio::IOStream::close | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Closes the stream, releasing resources related to it.

This will also closes the individual input and output streams, if they are not already closed.

Once the stream is closed, all other operations will return IO_ERROR_CLOSED. Closing a stream multiple times will not return an error.

Closing a stream will automatically flush any outstanding buffers in the stream.

Streams will be automatically closed when the last reference is dropped, but you might want to call this function to make sure resources are released as early as possible.

Some streams might keep the backing store of the stream (e.g. a file descriptor) open after the stream is closed. See the documentation for the individual stream for details.

On failure the first error that happened will be reported, but the close operation will finish as much as possible. A stream that failed to close will still return IO_ERROR_CLOSED for all operations. Still, it is important to check and report the error to the user, otherwise there might be a loss of data as all data might not be written.

If cancellable is not `0`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error IO_ERROR_CANCELLED will be returned. Cancelling a close will still leave the stream closed, but some streams can use a faster close that doesn't block to e.g. check errors.

The default implementation of this method just calls close on the individual input/output streams.

Since glibmm 2.22:

Parameters:

  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  `true` on success, `false` on failure.

bool Gio::IOStream::close | ( |  | ) |

void Gio::IOStream::close_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

void Gio::IOStream::close_async | ( | const SlotAsyncReady& | slot,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

bool Gio::IOStream::close_finish | ( | const Glib::RefPtr< AsyncResult >& | result | ) |

Closes a stream.

Since glibmm 2.22:

Parameters:

  result | A AsyncResult.

Returns:
  `true` if stream was successfully closed, `false` otherwise.

Glib::RefPtr<InputStream> Gio::IOStream::get_input_stream | ( |  | ) |

Gets the input stream for this object.

This is used for reading.

Since glibmm 2.22:

Returns:
  A InputStream, owned by the IOStream. Do not free.

Glib::RefPtr<OutputStream> Gio::IOStream::get_output_stream | ( |  | ) |

Gets the output stream for this object.

This is used for writing.

Since glibmm 2.22:

Returns:
  A OutputStream, owned by the IOStream. Do not free.

const GIOStream* Gio::IOStream::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

Reimplemented in Gio::FileIOStream, Gio::SocketConnection, Gio::TcpConnection, and Gio::UnixConnection.

GIOStream* Gio::IOStream::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

Reimplemented in Gio::FileIOStream, Gio::SocketConnection, Gio::TcpConnection, and Gio::UnixConnection.

GIOStream* Gio::IOStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented in Gio::FileIOStream, Gio::SocketConnection, Gio::TcpConnection, and Gio::UnixConnection.

bool Gio::IOStream::has_pending | ( |  | ) | const

Checks if a stream has pending actions.

Since glibmm 2.22:

Returns:
  `true` if stream has pending actions.

bool Gio::IOStream::is_closed | ( |  | ) | const

Checks if a stream is closed.

Since glibmm 2.22:

Returns:
  `true` if the stream is closed.

bool Gio::IOStream::set_pending | ( |  | ) |

Sets stream to have actions pending.

If the pending flag is already set or stream is closed, it will return `false` and set error.

Since glibmm 2.22:

Returns:
  `true` if pending was previously unset and is now set.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::IOStream > wrap | ( | GIOStream * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.